diff --git a/docs/storage.html.in b/docs/storage.html.in
index 26a949a..983568c 100644
--- a/docs/storage.html.in
+++ b/docs/storage.html.in
@@ -115,6 +115,7 @@
       </li>
     </ul>
 
+
     <h2><a name="StorageBackendDir">Directory pool</a></h2>
     <p>
       A pool with a type of <code>dir</code> provides the means to manage
@@ -153,6 +154,7 @@
       <li><code>iso</code>: CDROM disk image format</li>
       <li><code>qcow</code>: QEMU v1 disk image format</li>
       <li><code>qcow2</code>: QEMU v2 disk image format</li>
+      <li><code>qed</code>: QEMU Enhanced Disk disk image format</li>
       <li><code>vmdk</code>: VMWare disk image format</li>
       <li><code>vpc</code>: VirtualPC disk image format</li>
     </ul>
@@ -164,7 +166,6 @@
       either <code>qemu-img</code> or <code>qcow-create</code> tools
       are present. The others are dependent on support of the
       <code>qemu-img</code> tool.
-
     </p>
 
     <h2><a name="StorageBackendFS">Filesystem pool</a></h2>
@@ -184,6 +185,7 @@
         &lt;name&gt;virtimages&lt;/name&gt;
         &lt;source&gt;
           &lt;device path="/dev/VolGroup00/VirtImages"/&gt;
+          &lt;format type="auto"/&gt;
         &lt;/source&gt;
         &lt;target&gt;
           &lt;path&gt;/var/lib/virt/images&lt;/path&gt;
@@ -254,6 +256,7 @@
         &lt;source&gt;
           &lt;host name="nfs.example.com"/&gt;
           &lt;dir path="/var/lib/virt/images"/&gt;
+          &lt;format type="auto"/&gt;
         &lt;/source&gt;
         &lt;target&gt;
           &lt;path&gt;/var/lib/virt/images&lt;/path&gt;
@@ -328,6 +331,7 @@
         &lt;name&gt;sda&lt;/name&gt;
         &lt;source&gt;
           &lt;device path='/dev/sda'/&gt;
+          &lt;format type='gpt'/&gt;
         &lt;/source&gt;
         &lt;target&gt;
           &lt;path&gt;/dev&lt;/path&gt;
@@ -361,6 +365,9 @@
       <li>
         <code>sun</code>
       </li>
+      <li>
+        <code>lvm2</code>
+      </li>
     </ul>
     <p>
       The <code>dos</code> or <code>gpt</code> formats are recommended for
@@ -433,6 +440,7 @@
       The iSCSI volume pool does not use the volume format type element.
     </p>
 
+
     <h2><a name="StorageBackendSCSI">SCSI volume pools</a></h2>
     <p>
       This provides a pool based on a SCSI HBA. Volumes are preexisting SCSI
@@ -465,6 +473,7 @@
       The SCSI volume pool does not use the volume format type element.
     </p>
 
+
     <h2><a name="StorageBackendMultipath">Multipath pools</a></h2>
     <p>
       This provides a pool that contains all the multipath devices on the
@@ -497,18 +506,19 @@
       The Multipath volume pool does not use the volume format type element.
     </p>
 
+
     <h2><a name="StorageBackendRBD">RBD pools</a></h2>
     <p>
       This storage driver provides a pool which contains all RBD
       images in a RADOS pool.  RBD (RADOS Block Device) is part
       of the Ceph distributed storage project.<br/>
-      This backend <i>only</i> supports Qemu with RBD support. Kernel RBD
+      This backend <i>only</i> supports QEMU with RBD support. Kernel RBD
       which exposes RBD devices as block devices in /dev is <i>not</i>
       supported. RBD images created with this storage backend
       can be accessed through kernel RBD if configured manually, but
       this backend does not provide mapping for these images.<br/>
-      Images created with this backend can be attached to Qemu guests
-      when Qemu is build with RBD support (Since Qemu 0.14.0). The
+      Images created with this backend can be attached to QEMU guests
+      when QEMU is build with RBD support (Since QEMU 0.14.0). The
       backend supports cephx authentication for communication with the
       Ceph cluster. Storing the cephx authentication key is done with
       the libvirt secret mechanism. The UUID in the example pool input
@@ -552,7 +562,7 @@
        &lt;/volume&gt;</pre>
 
     <h3>Example disk attachement</h3>
-    <p>RBD images can be attached to Qemu guests when Qemu is built
+    <p>RBD images can be attached to QEMU guests when QEMU is built
     with RBD support. Information about attaching a RBD image to a
     guest can be found
     at <a href="formatdomain.html#elementsDisks">format domain</a>
@@ -568,6 +578,7 @@
       The RBD pool does not use the volume format type element.
     </p>
 
+
     <h2><a name="StorageBackendSheepdog">Sheepdog pools</a></h2>
     <p>
       This provides a pool based on a Sheepdog Cluster.
@@ -611,7 +622,7 @@
        &lt;/volume&gt;</pre>
 
     <h3>Example disk attachment</h3>
-    <p>Sheepdog images can be attached to Qemu guests.
+    <p>Sheepdog images can be attached to QEMU guests.
     Information about attaching a Sheepdog image to a
     guest can be found
     at the <a href="formatdomain.html#elementsDisks">format domain</a>